
#include "config.h"


#ifdef AUTH_PASSWD

#include <sys/types.h>
#include <pwd.h>

#include "popd.h"

int auth_passwd(struct pop_session *session) {
	struct	PWSTRUCT_TYPE	*pw;
#ifdef SHADOW_PASSWD
	struct	passwd		*pwuid;
#endif /* SHADOW_PASSWD */

	pw=PWSTRUCT_GET_METHOD(session->username);

	if (!pw) 
		return(POP_AUTH_ERROR);
	
	/* compare the crypted passwords */
	if (strcmp(pw->PWSTRUCT_PW_MEMBER,(char *) crypt(session->password,pw->PWSTRUCT_PW_MEMBER))) {
		/* Close passwd */
		PWSTRUCT_FREE_METHOD();
		/* Exit -> error */
		return(POP_AUTH_FAILED);
	}
#if !defined(SHADOW_PASSWD) || defined(PWSTRUCT_UID_MEMBER)
	/* Copy uid and gid */
	session->uid=pw->PWSTRUCT_UID_MEMBER;
	session->gid=pw->PWSTRUCT_GID_MEMBER;
#endif /* !SHADOW_PASSWD || PWSTRUCT_UID_MEMBER */

	PWSTRUCT_FREE_METHOD();

#if defined(SHADOW_PASSWD) && !defined(PWSTRUCT_UID_MEMBER)
	pwuid=getpwnam(session->username);
	if (!pw)
		return(POP_AUTH_ERROR);

	/* Copy uid and gid */
	session->uid=pwuid->pw_uid;
	session->gid=pwuid->pw_gid;

	endpwent();
#endif /* SHADOW_PASSWD && !PWSTRUCT_UID_MEMBER */

	return(POP_AUTH_SUCCESS);
}

#endif /* AUTH_PASSWD */
