#include "config.h"

#include <stdio.h>
#include <unistd.h>
#include <syslog.h>

#include "popd.h"

int cmd_pop_user(char **cmd,struct pop_session *session) {

	strncpy(session->username,cmd[1],MAX_POP_USERNAME);

	fprintf((FILE *) session->out, "+OK Nice to meet you %s\r\n",session->username);
	
	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_pass(char **cmd,struct pop_session *session) {

	strncpy(session->password,cmd[1],MAX_POP_PASSWORD);
	
	if (AUTHENTICATE_USER(session) == POP_AUTH_SUCCESS) {

		setgid(session->gid);
		setuid(session->uid);

		syslog(LOG_INFO,"user %s authenticated successfully", session->username);

		if (MAILBOX_OPEN(session) == MAILBOX_OPEN_FAILURE) {
			fprintf((FILE *) session->out, "-ERR Failure while opening mailbox\r\n");

			syslog(LOG_WARNING,"error opening mailbox - exiting");

			return(CMD_POP_RESULT_QUIT);
		}

		syslog(LOG_INFO,"messages %d bytes %d",session->messages_count,session->messages_size);

		fprintf((FILE *) session->out, "+OK Welcome - you did well on correct typeing ... \r\n");
		session->authenticated=1;

		return(CMD_POP_RESULT_SUCCESS);
	} else {
		POP_ERR

		fprintf((FILE *) session->out, "+ERR Hacking ey ?\r\n");

		session->pwcounter++;
		if (session->pwcounter >= POP_MAX_PW_TRIES) {

			syslog(LOG_ERR,"user %s disconnected due to repeated authentication failures", session->username);

			/* FIXME Do we need to send some QUIT notices ? */
			return(cmd_pop_quit_noupdate(cmd,session));
		}

		syslog(LOG_WARNING,"user %s authentication failure", session->username);
	}
}
