
#include <stdio.h>
#include <syslog.h>
#include "popd.h"


int cmd_pop_noop(char **cmd, struct pop_session *session) {

	fprintf((FILE *) session->out,"+OK\r\n");

	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_retr(char **cmd,struct pop_session *session) {
	char		*inval=NULL;
	long int	i;

	i=strtol(cmd[1],inval,10);
	
	if (inval != 0x0 || i <= 0 || i > session->messages_highwater+1) {
		fprintf((FILE *) session->out, "-ERR Are you shure i have the message ?\r\n");
		return(CMD_POP_RESULT_FAILURE);
	} else if (session->messages[i-1].deleted == 1) {
		fprintf((FILE *) session->out, "-ERR Hey - you have already deleted that !\r\n");
		return(CMD_POP_RESULT_FAILURE);
	} else if (MAILBOX_RETR(session,(int ) i-1) == CMD_POP_RESULT_FAILURE) {
		fprintf((FILE *) session->out, "-ERR Whoppala - wheres the message ???\r\n");
		return(CMD_POP_RESULT_FAILURE);
	}

	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_rset(char **cmd,struct pop_session *session) {

	int	i;

	for(i=0;i<=session->messages_highwater;i++) {
		if (session->messages[i].deleted != 0) {
			session->messages[i].deleted=0;
			session->messages_count++;
			session->messages_size+=session->messages[i].msg_size;
		}
	}

	fprintf((FILE *) session->out,"+OK %d %d\r\n",
				session->messages_count+1,
				session->messages_size);

	return(CMD_POP_RESULT_SUCCESS);
	
}

int cmd_pop_stat(char **cmd,struct pop_session *session) {

	fprintf((FILE *) session->out,"+OK %d %d\r\n",
				session->messages_count+1,
				session->messages_size);

	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_uidl(char **cmd,struct pop_session *session) {

	int		i,
			j=0;
	char		*inval=NULL;

	/* Do we have an parameter ? */
 	if (cmd[1] != NULL) {
		j=strtol(cmd[1],inval,10);

		if (inval != 0x0 || j <= 0 || j > session->messages_highwater+1) {
			fprintf((FILE *) session->out, "-ERR Are you shure i have the message ?\r\n");
			return(CMD_POP_RESULT_FAILURE);
		}
	}

	/* we do have an parameter for list */
	if (j != 0) {
		if (session->messages[j-1].deleted != 0) {
			fprintf((FILE *) session->out,
						"-ERR gone forever !\r\n");
			return(CMD_POP_RESULT_FAILURE);
		} else {
			fprintf((FILE *) session->out,
						"+OK %d %lu\r\n",
							session->messages[j-1].msg_no+1,
							session->messages[j-1].uidl);
		}
	/* list full mailbox content */					
	} else {
		fprintf((FILE *)session->out,"+OK\r\n");
		for(i=0;i<=session->messages_highwater;i++) {
			if (session->messages[i].deleted == 0) {
				fprintf((FILE *) session->out,
						"%d %lu\r\n",session->messages[i].msg_no+1,
							session->messages[i].uidl);
			}
		}
		fprintf((FILE *)session->out,".\r\n");
	}

	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_list(char **cmd,struct pop_session *session) {
	int			i,
				j=0;
	char			*inval=NULL;

	/* Do we have an parameter ? */
 	if (cmd[1] != NULL) {
		j=strtol(cmd[1],inval,10);
		if (inval != 0x0 || j <= 0 || j > session->messages_highwater+1) {
			fprintf((FILE *) session->out, "-ERR Are you shure i have the message ?\r\n");
			return(CMD_POP_RESULT_FAILURE);
		}
	}
	
	/* we do have an parameter for list */
	if (j != 0) {
		if (session->messages[j-1].deleted != 0) {
			fprintf((FILE *) session->out,
						"-ERR gone forever !\r\n");
			return(CMD_POP_RESULT_FAILURE);
		} else {
			fprintf((FILE *) session->out,
						"+OK %d %d\r\n",
							session->messages[j-1].msg_no+1,
							session->messages[j-1].msg_size);
		}
	/* list full mailbox content */					
	} else {
		fprintf((FILE *) session->out,
					"+OK %d messages (%d octets)\r\n",
						session->messages_count+1,
						session->messages_size);

		for(i=0;i<=session->messages_highwater;i++) {
			if (session->messages[i].deleted == 0) {
				fprintf((FILE *) session->out,
						"%d %d\r\n",session->messages[i].msg_no+1,
							session->messages[i].msg_size);
			}
		}
		fprintf((FILE *) session->out,".\r\n");
	}

	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_dele(char **cmd,struct pop_session *session) {
	char		*inval=NULL;
	long int	i;

	i=strtol(cmd[1],inval,10);

	if (inval != 0x0 || i <= 0 || i > session->messages_highwater+1) {
		fprintf((FILE *) session->out, "-ERR Are you shure i have the message ?\r\n");
		return(CMD_POP_RESULT_FAILURE);
	} else if (session->messages[i-1].deleted == 1) {
		fprintf((FILE *) session->out, "-ERR Hey - you have already deleted that !\r\n");
		return(CMD_POP_RESULT_FAILURE);
	} else if (MAILBOX_DELE(session,(int ) i-1) == CMD_POP_RESULT_FAILURE) {
		fprintf((FILE *) session->out, "-ERR Hmmm - it wont go !\r\n");
		return(CMD_POP_RESULT_FAILURE);
	}
	
	return(CMD_POP_RESULT_SUCCESS);
}

int cmd_pop_quit_noupdate(char **cmd,struct pop_session *session) {

	MAILBOX_CLOSE(session,DONT_UPDATE);

	fprintf((FILE *) session->out, "+OK Whoppala - popped enough ?\r\n");
	return(CMD_POP_RESULT_QUIT);
}

int cmd_pop_quit_update(char **cmd,struct pop_session *session) {

	MAILBOX_CLOSE(session,DO_UPDATE);

	fprintf((FILE *) session->out, "+OK Whoppala - popped enough ?\r\n");
	return(CMD_POP_RESULT_QUIT);
}
