#define PROTOCOL_TCP	6
#define TCP_PORT_POP3	110
#define	NUM_BACKLOG	4
#define MAX_LINESIZE	256
#define CMD_TIMEOUT	240

#define MAX_POP_USERNAME	128
#define MAX_POP_PASSWORD	128
#define MAX_POP_MBOXPATH	256
#define MAX_HOSTNAME		64
#define POP_MAX_PW_TRIES	3

#define ERR_CMD_DELAY		0

#define	USE_LIB_WRAP		
#define	LIB_WRAP_DAEMON		"pop3"

#define LOG_UNKNOWN

#define LOCK_LIBLOCKFILE
#define LOCK_RETRY		5
#define LOCK_EXTENSION		".lock"

#define	MAILBOX_BSD
#define	MAILBOX_BSD_BLOCKSIZE	8193
/* #define MAILBOX_BSD_DEBUG */

#define MAILBOXPATH "/var/spool/mail/"

#define MAILSEPERATOR		"From "

#define MESSAGES_INMEM		1024

#define UIDL_MAGIC		55045

/*
 *
 *
 * Authentication
 *
 *
 */

#define AUTH_LDAP 
#define LDAP_FILTER "(&(objectClass=mailRecipient)(uid=%s))"
#define LDAP_FILTER_BUFSIZE 128
#define LDAP_SERVER "move.mediaways.net"
#define LDAP_BINDDN "o=Privates Internet Ostwestfalen-Lippe, c=DE"

#define LDAP_MAILSPOOL_ATTRIBUTE "mailmessagestore"

/* Define this if different from BINDDN */
/* #define LDAP_SEARCH_ROOT "o=Privates Internet Ostwestfalen-Lippe, c=DE" */

/* Set these if you want the popd to change uid */
#define LDAP_CHANGEUID	65534
#define LDAP_CHANGEGID	65534


/* #define AUTH_PASSWD */
/* #define SHADOW_PASSWD */


/*
 *
 * DONT TOUCH ANYTHING AFTER THIS 
 *
 */

#ifdef SHADOW_PASSWD

#include <shadow.h>
#define PWSTRUCT_TYPE spwd
#define PWSTRUCT_GET_METHOD getspnam
#define PWSTRUCT_FREE_METHOD endspent
#define	PWSTRUCT_PW_MEMBER sp_pwdp
/* #define PWSTRUCT_UID_MEMBER sp_uid */
/* #define PWSTRUCT_GID_MEMBER sp_gid */

#else 

#define PWSTRUCT_TYPE passwd
#define PWSTRUCT_GET_METHOD getpwnam
#define PWSTRUCT_FREE_METHOD endpwent
#define	PWSTRUCT_PW_MEMBER pw_passwd
#define PWSTRUCT_UID_MEMBER pw_uid 
#define PWSTRUCT_GID_MEMBER pw_gid

#endif /* SHADOW_PASSWD */

#if (ERR_CMD_DELAY > 0)
#define POP_ERR sleep(ERR_CMD_DELAY);
#else
#define POP_ERR 
#endif

#ifdef MAILBOX_BSD
#define MAILBOX_OPEN mailbox_bsd_open
#define MAILBOX_CLOSE mailbox_bsd_close
#define MAILBOX_RETR mailbox_bsd_retr
#define MAILBOX_DELE mailbox_bsd_dele
#endif

#ifdef LOCK_LIBLOCKFILE
#define LOCK_LOCK liblockfile_lock
#define LOCK_UNLOCK liblockfile_unlock
#define LOCK_REFRESH liblockfile_refresh
#endif
